import { jsx } from "@builder.io/qwik/jsx-runtime";
import { getBlockActions } from "../../../functions/get-block-actions.qwik.mjs";
import { getBlockProperties } from "../../../functions/get-block-properties.qwik.mjs";
import { component$, useComputed$, Slot } from "@builder.io/qwik";
const InteractiveElement = component$((props) => {
  const attributes = useComputed$(() => {
    return props.includeBlockProps ? {
      ...getBlockProperties({
        block: props.block,
        context: props.context
      }),
      ...getBlockActions({
        block: props.block,
        rootState: props.context.rootState,
        rootSetState: props.context.rootSetState,
        localState: props.context.localState,
        context: props.context.context
      })
    } : {};
  });
  return /* @__PURE__ */ jsx(props.Wrapper, {
    ...props.wrapperProps,
    attributes: attributes.value,
    children: /* @__PURE__ */ jsx(Slot, {})
  });
});
export {
  InteractiveElement,
  InteractiveElement as default
};
