import { getFunctionArguments } from "../helpers.qwik.mjs";
const runInBrowser = ({ code, builder, context, event, localState, rootSetState, rootState }) => {
  const functionArgs = getFunctionArguments({
    builder,
    context,
    event,
    state: flattenState({
      rootState,
      localState,
      rootSetState
    })
  });
  return new Function(...functionArgs.map(([name]) => name), code)(...functionArgs.map(([, value]) => value));
};
function flattenState({ rootState, localState, rootSetState }) {
  return new Proxy(rootState, {
    get: (target, prop) => {
      if (localState && prop in localState) {
        return localState[prop];
      }
      const val = target[prop];
      if (typeof val === "object" && val !== null) {
        return flattenState({
          rootState: val,
          localState: void 0,
          rootSetState: rootSetState ? (subState) => {
            target[prop] = subState;
            rootSetState(target);
          } : void 0
        });
      }
      return val;
    },
    set: (target, prop, value) => {
      if (localState && prop in localState) {
        throw new Error("Writing to local state is not allowed as it is read-only.");
      }
      target[prop] = value;
      rootSetState == null ? void 0 : rootSetState(target);
      return true;
    }
  });
}
export {
  flattenState,
  runInBrowser
};
