import { isBrowser } from "../is-browser.qwik.mjs";
import { isEditing } from "../is-editing.qwik.mjs";
import { getUserAttributes } from "../track/helpers.qwik.mjs";
const getFunctionArguments = ({ builder, context, event, state }) => {
  return Object.entries({
    state,
    Builder: builder,
    // legacy
    builder,
    context,
    event
  });
};
const getBuilderGlobals = () => ({
  isEditing: isEditing(),
  isBrowser: isBrowser(),
  isServer: !isBrowser(),
  getUserAttributes: () => getUserAttributes()
});
const parseCode = (code, { isExpression = true }) => {
  const useReturn = (
    // we disable this for cases where we definitely don't want a return
    isExpression && !(code.includes(";") || code.includes(" return ") || code.trim().startsWith("return "))
  );
  const useCode = useReturn ? `return (${code});` : code;
  return useCode;
};
export {
  getBuilderGlobals,
  getFunctionArguments,
  parseCode
};
